%House animation 1 
% As shown in lecture on April 2, 2020
% Primitive method:  Plot, plot, plot and plot again.
% This controls number of frames, but not the speed of play


clear all

houseref =[  % drawing of a square house and roof
    0 0
    1 0 
    1 1
    0 1
    0 0
    NaN NaN
    -.5 .5
    .5 1.5
    1.5 .5]'; % note the transpose; first row is x, 2nd is y


house = houseref;  % just to get in the habit of not modifying houseref

%%%%%%%%%%%%%%
% These next 5 lines aren't really needed, they are just to draw the first
% frame.  In house2.m, they are needed, so they are here for practice
x = house(1,:); % Pull of x and y coordinates for plotting
y = house(2,:);

plot(x,y);  
axis equal;    % This is needed so the square will look square
axis([-2 2 -2 2]); % this is needed so the frame of the picture stays fixed
%%%%%%%%%%%%%%%



tend = 3;    % tend is the end 'time', not real time
npts = 100;  % number of points in the whole animation
k = 2*pi/3;      % k is a speed up factor
t     = linspace(0, tend, npts);  % one entry for each movie frame
theta = k*t; % big k means bigger range of theta is animated

tic  %start the stop watch, read stop watch with toc.
%%%%%%%%%%%%%
for i = 1:npts           % once through the loop for each frame
    s = sin(theta(i));   % short hand, so the matrix R will look cleaner
    c = cos(theta(i));
    R = [ c -s;          % TThe rotation matrix
          s  c  ];
    house = R*houseref;  % Main code line for this lecture
    x = house(1,:);      % Note:  house is houseref, rotated 
    y = house(2,:);

plot(x,y,'LineWidth', 5);  % Insulate the walls and roof
axis equal;
axis([-2 2 -2 2]);
shg
end

disp('PLOT, PLOT, PLOT, PLOT ... METHOD')
disp(['The number of frames shown was: ' num2str(npts)])
disp(['Duration of move in seconds:    ' num2str(toc)])
disp(['Frames per second:              ' num2str(npts/toc)])
     
