%House animation 2
% From lecture on April 2, 2021
% Fancier animation
% This controls the actual duration of the movie and the speed of the movie
% As many frames as possible are drawn.
clear all

houseref =[    % picture of house
    0 0
    1 0 
    1 1
    0 1
    0 0
    NaN NaN
    -.5 .5
    .5 1.5
    1.5 .5]';   %transpose to make x and y rows.

house = houseref;  % Get used to drawing house and leaving houseref alone

x = house(1,:); y = house(2,:); % get  x and y for plot
h=plot(x,y,'LineWidth', 5);     % create plot object named 'h'
axis equal;                     % make shapes look like their proper shapes
axis([-2 2 -2 2]);              % Keep the view region constant

tend = 4;                     % The actual duration of the movie
k    = pi*2/4;                % Speed up factor, does not change movie duration


tic                        % Start stop watch. This is essential.
%%%%%%%%%%%%%
i=0;                       % Frame counter. Not essential. 
while toc <= tend +.01     % Keep movie going until time has passed, + a hair.
    i=i+1;                 % Increment frame counter
    t = toc;               % Read the present time
    theta = k*t;           % Theta goes by faster with bigger k
    s = sin(theta);        % Define s and c to make rotation matrix look tidy
    c = cos(theta);
    R = [ c -s;
          s  c  ];
    house = R*houseref;     % Rotate the house
    h.XData = house(1,:);   % Update the graphics object h
    h.YData = house(2,:);   % The rest of the picture is the same
drawnow                     % Redraw the figure with new x and y data
end

disp('CONTROLLED SPEED AND DURATION METHOD (gives more frames per second)')
disp(['The number of frames shown was: ' num2str(i)])
disp(['Duration of move in seconds:    ' num2str(t)])
disp(['Frames per second:              ' num2str(i/t)])
